Changes since Roxen Challenger 1.3.121 Yellow
-----------------------------------------------

o Fixed the manual-server server template.

o Ignore \r in .htaccess passwd and group files.

o ldapuserauth.pike:
  o Added checking of hashed password (SHA, MD5, CRYPT);
  o Added 'userPassword' map

o Fixed bug in sqltag module. (con->error() == 0 was not handled.)

o Added the image conversion module.

o Fixed typo in servlet.pike that prevented it from compiling.

o Added optional displaying of dates in directory listings.

o Added kludge for problem with getting separate wizard instances for
  each page with IE.

o Added better configure tests for UnixWare and OpenServer.  (Thanks
  to Boyd Lynn Gerber)

Changes since Roxen Challenger 1.3.120 Yellow
-----------------------------------------------

o HTML-quoted the output from information tags in htmlparse that
  weren't already doing that. (security fix)

o Fixed font listings in wizards and config action.

Changes since Roxen Challenger 1.3.115 Yellow
-----------------------------------------------

o Rigged the binary build-script to make binaries that work on
  unpatched AIX4.2 and HPUX10.20 systems.

o The SSI compat command, <!--#exec cgi="..."--> changed to not use
  the cache per default. If you do want to use the cache, use the
  <cgi> tag or <insert file=...> instead.
 
o Added byte-range handling. (Thanks to David Hedbor at Real Audio.)
  note: Experimental and must be enabled in global variables.

o Added a supports lookup cache. 

o Fixed start --version to actually output the correct version.

o Fixed ABS to print out the backtraces of all threads if engaged.

o Added workaround in the CGI-module for systems that don't like
  negative UIDs/GIDs.

o Fixed new "power by"-icons.

o LDAP upgrades by Honza.

o Made new manuals. Now includes the mythical programmers manual.


Changes since Roxen Challenger 1.3.111 Yellow
-----------------------------------------------

o Added some files that were lacking to get the Servlet support working.

o Fixed a problem in the SQL-module which prevented proper garbage collection,
  resulting in stale connections not being closed.

o Made a year 2000 compliance check. As expected no year 2000 bugs
  were found, but a few other date-related bugs were found and fixed.

o Added the Odbc-module to the GPLed Challenger.

o Fixed <imgs> to work in virtual filesystems.

o Fixed bug in the Croatian, Czech and Italian language modules that
  made the date() modes "full" and "date" always report the current
  year as year.

o Improved trace outputs from the Java servlets module.

o Fixed the request count in the ip-less hosting module.

o Changed 1.2 to 1.3 in the documentation and test files.

o Changed COPYING to better reflect the situation with RSA patents.

o Brought back extern/README to reality as of 1999.

o Disabled the socketpair kludge for Linux. Roxen needs more
  functionality than Linux broken socketpair provides, so let it fall
  back on socketpair ultra instead. This might break CGI-scripts
  on Linux, but now we have a chance of fixing it in pikes fall
  backs. Tests with Linuxen that we have available show no breakage.

o Fixed several bugs in the CGI-support.

o Updated the manual.

o Fixed bug in font loader.

o Fixed <gtext-id> to work as it used to before the cache-rewrite.

o Added <gtext-url> that incorporates the behavior <gtext-id> just
  was fixed not to have..


Changes since Roxen Challenger 1.3.107 Yellow
-----------------------------------------------

o Updated documentation from manual server. Including the built in
  RXML help.

o Fixed bug in gtext that generated errornous buttons.

o Lots of fixes for NT.

o Fixed thread problem in Yabu.


Changes since Roxen Challenger 1.2.95 Yellow
-----------------------------------------------

o Reverted the error messages introduced in 1.2.95.

o Automated the CLASSPATH setting (for servlets).

o Install script now tries to locate installed databases etc and set
  environment variables accordingly.

o Fixed resolving to handle computers without /etc/resolv.conf

o Added option to build 40-bit version of the Crypto module. (Ugh.)

o Added internal handling of cgi-scripts. This eliminates the need for
  an external cgi-script wrapper and speeds up execution.

o Rewrote CGI-module. In contrast to the old cgi.pike this one
  actually looks nice. Except for code that you can read and enjoy
  there is now a uid and group cache.

o Added possibility to parse the output from CGI-scripts. Possibly
  putting an end to the biggest FAQ of them all.

o Added <cgi> tag.

o Added support for libiodbc.

o Changed default build from 1.2 to 1.3.

o Fixed so that Challenger doesn't unnecessarily try to become
  superuser to write config files.

o Fixed so that Challenger doesn't unnecessarily change permissions on
  files.

NOTE: The two changes above can lead to Challenger being unable to
      read files from an old installation. Check permissions on the
      following files to make sure the user you are running Roxen as
      can read (and write) them:
 
 etc/supports
 configurations/*
 logs/*
 bgcache/*

o Added internal mountpoint for usage with modules that need a mount
  point to export data and converted gtext to use it.

o Added a global persistent argument cache and converted gtext to use it.

o Fixed bug in SSL that that broke <aconf> on Unix and SSL on NT.

o Added kludge for glibc2.1

o Added config action that makes a self-signed SSL certificate.

o Added quoting to insert. When used with the argument variable or
  cookie the inserted string will will have "<", ">", "&",""" ,"'"
  and ":" quoted to HTML entities. Use the argument encode=none to
  avoid this.

o Added ":" to the characters that are quoted by default by formoutput,
  sqloutput.

NOTE: The two quoting changes above might break RXML-pages the rely on
      unquoted content. Those changes was therefore not made lightly, but
      due to security concerns it had to be done.

o Moved newpikescript.pike to unfinishedmodules/

o Added truetype font support.

o Support for jpeg, gif and png as indata for gtext.

o Added <fsize> tag.

o Added printable PDF-versions of the manuals.



Changes since Roxen Challenger 1.2.93 Yellow
-----------------------------------------------

o Fixed bug in shutdown code.

o Added better error messages when failing to write the configuration.


Changes since Roxen Challenger 1.2.87 Yellow
-----------------------------------------------

o Added the <scope> tag.

o Modified the scope for <formoutput>. Should fix problems introduced
  in 1.2.87.

o Fixed bug in Postgres module. Thanks to Francesco Chemolli.

o Fixed bug in SQLuserdb.


Changes since Roxen Challenger 1.2.77 Yellow
-----------------------------------------------

o Fixed problems with limits in tar by archiving the manual separately.

o Fixed old bug in roxenlib where the id object wasn't properly
  copied. This has affected several parts of Roxen, among other
  things possibly resulting in broken gtexts.

o Fixed race in gtext.

o Replaced ftp with ftp2. Configurations will automaticly change from
  ftp2 to ftp.

o Added better documentation for virtual user hosting.


Changes since Roxen Challenger 1.2.76 Yellow
-----------------------------------------------

o Makefiles fixed to work with !gmake again.

o Fixed --pid-file.

o Quoting fixes and changes.

o Added HTTP MOVE to filesystem.pike (Roaming access).


Changes since Roxen Challenger 1.2.61 Yellow
-----------------------------------------------

o Added the manual and manual-server to the distribution.

o Fixed certificate generation to work with Pike 0.6.

o Fixed bug related to insert and multiple layers of query variables. (SSI)

o Added support for SSI #set.

o Fixed the "striped polygons"-bug in Pike 0.5's Image package.

o Improved documentation for proxy security patterns.


Changes since Roxen Challenger 1.2.48 Yellow
-----------------------------------------------

o GDBM package removed from the distribution.

o Updated documentation.

o Lots of new internal documentation added for RXML tags and containers.

o Fixed recursion bug in <insert> when trying to insert empty files in
  combination with use of PATH_INFO

o Fixed the bug that ate POST's when using SSL.

o DOCUMENT_URI now handled correctly.

o Borderwidth is no longer configurable in the language module.


Changes since Roxen Challenger 1.2.47 Yellow
-----------------------------------------------

o FreeBSD thread fix.

o Updated Czech language module.


Changes since Roxen Challenger 1.2.46 Infrared
-----------------------------------------------

o Improved Postgres configure tests.

o Fixed PATH_INFO to work when using <insert>.

o Modified <insert> so that appended query variables are sent to the
  included script.


Changes since Roxen Challenger 1.2.45 Yellow
-----------------------------------------------

o Fixed dynamic linking for FreeBSD ELF. 


Changes since Roxen Challenger 1.2.43 Yellow
-----------------------------------------------

o Fixed bug that made the config object sent to modules sometimes be 0.

o Reenabled the decoding of URLs in a way that shouldn't break anything.

o Fixed Business Graphics to use background and foreground colors if available.

o Made a new SSL3 demo certificate that expires in the year 2011.

o Changed name of "Directory Parsing Module MkII" to "Extended
  Directory Parsing Module"

o Modified SQLuserdb to use the standard SQL-URL to specify database and its
  metadata.


Changes since Roxen Challenger 1.2.42 Red
-----------------------------------------------

o Removed Wais and Gopher from the proxy template.

o Moved hostredirect.pike to old_modules/.

o Fixed bug in the Counter module.

o Fixed bug in the Pathinfo module.

o Made configuration of container name in the Indirect href module
  into an expert variable.

o Fixed Business Graphics to use the global default font.

o Repaired support for multiple font dirs.

o Added support for multiple checkboxes with the same name in wizards.
  Thanks to Francesco Chemolli.


Changes since Roxen Challenger 1.2.41 Yellow
-----------------------------------------------

o Changed some configure rules for MySQL.

o Updated documentation for security patterns.

o Fixed ftp2.

o Fixed the global tag attributes.


Changes since Roxen Challenger 1.2.37 Yellow
-----------------------------------------------

o Fixed broken dependencies rule.

o Fixed bug in userfs banish list.

o Fixed compability with the old language module.

o Config action "Thread backtrace" removed from the 1.2 dist.

o Improved Bussiness Graphics cache.

o Separated Roxen 1.2 from the main Roxen cvs-tree. There is now an
  absolute feature freeze in effect.


Changes since Roxen Challenger 1.2.36 Yellow
-----------------------------------------------

o PATH_INFO handling has been extracted into a separate module.

o The CGI module now uses the PATH_INFO module to do PATH_INFO handling.

o Added option to disable the user listing in the userfs module.

o Added new tag: <undefine>.

o Added config action: Thread backtrace.

o Usefull comments added to some files in base_server  :-)

o Removed Pike0.6 from the standard 1.2 dist.


Changes since Roxen Challenger 1.2.35 Yellow
-----------------------------------------------

o #if'ed out a few things in modules that won't compile with 0.5.

o Pike is now by default compiled without rtldebug. To enable debug
  configure --with-rtldebug.

o Some SSI updates.

o <expire-time> now supports the argument "now".

o Updated Pike 0.6

o Fixed bug in module security levels and improved documentation.


Changes since Roxen Challenger 1.2.34 Yellow
-----------------------------------------------

o Added <recursive-output>, <auth-reqiured> and <expire-time>

o Fixed install

o Updated Pike 0.6


Changes since Roxen Challenger 1.2.32 Yellow
-----------------------------------------------

o Updated pike/0.5/lib/modules/Crypto/rsa.pike to work with the new
  SSL3 module.

o Added support for dynamic modules in Pike 0.6 on UnixWare.
  Thanks to Honza Petrous <hop@unibase.cz>.

o accept_and_parse.c should now compile on Linux.
  Thanks to Brian Lenihan <brianl@prognet.com>.

o Fixed bug in the start-script.

o Disabled some debug.

o The HTTP relay module now works with SSL3.

o Removed some dead code from the rimage module.

o Fixed logging bug in ftp2.pike.

o Added support for MySQL on NT.

o Added new variable to decide what tags will be parsed for colors in
  gtext.

  OBSERVE: All setting concerning parsing for colors in gtext will
           return to the default values with this release. So you will
           have to reconfigure if you have earlier disabled parsing of
           some tags.

o Fixed some bugs that prevented the language module from working.
  Thanks to Peter Holzer <hjp@wsr.ac.at>.


Changes since Roxen Challenger 1.2.31 Yellow
-----------------------------------------------

o Added support for SSL3 ServerKeyExchange.
  This makes SSL3 work with Netscape 4.5.

o First release of the accept-and-parse optimized HTTP module. EXPERIMENTAL.
  NOTE: Modules returning http_stream (eg the CGI module) are not
        supported yet.

o New module: Roxen image manipulation tag.
  This is a layer based image manipulation tag with plugins.

o Made kill CGI scripts after X real time minute(s) a VAR_MORE instead
  of VAR_EXPERT and added a check to only allow killing of pid > 1.

o Rewrote the "Reload configurations from disk" action, by adding a
  stat cache and moving the entire functionality to roxen.pike. Fixed
  it so that it only (re)loads new or changed configs, and that it
  correctly removes modules and "rmed" configurations. Also attached
  this functionality to SIGHUP. This means that if you add a config or
  change it on the disk, a simple SIGHUP will reload it.

o Added a "reload" target to the tools/init.d_roxen and changed
  restart to only (try to) kill the Roxen process. Also added a new
  variable, "flags" which makes it easy to for example enable threads
  (without editing the file in 4711 places).

o Fixed the "clean" target in several Makefiles.

o Updated the Postgress module to 1.0.3 level. Thanks to Francesco Chemolli.

o Improved support for threads on AIX.

o Improved support for HPUX.

o Improved support for IRIX.

o Fixed several obscure bugs in Pike 0.6.

o Added some checks for stack overflow to Pike 0.6.

o Improved support for NT.

o Fixed several compilation warnings when compiling Pike 0.6.

o Added option --truss to the start-script (only usefull on Solaris).

o Added options --without-debug, --file-profile to the start-script.

o Improved help in the start-script.

o The RoxenConfig cookie now expires two years into the future.

o Automatic redirects now support SSL.

o Now reloads all configurations on SIGHUP.

o Improved quoting support in the *output tags.

o Added new module type: MODULE_EXPERIMENTAL.

o Improved parsing of the query in the Resolv Path action.

o Added setting of id->misc->cacheable to most modules.

o Disabled the automatic redirect from /foo/file.html/ to /foo/file.html
  to be able to support the path-info "/".

o Fixed a few bugs in the userfs module.

o Optimized htaccess to use less reverse IP lookups.

o Improved the gtext cache performance.

o Added support for logging of stderr to the CGI module.

o Killframe now checks the client.

o Reenabled the extra_extension code.

o Some default images have been changed.

o The tools/init.d_roxen script has been cleaned up.


Changes since Roxen Challenger 1.2.30 Yellow
-----------------------------------------------

o Thread dead-lock bug in Pike 0.6 hopefully fixed.

o Fixed serious security bug if Roxen is run with Pike 0.5 and with
  SSI-exec enabled.

o Fixed several serious thread dead-lock bugs in Pike 0.6.

o Pike 0.6 now supports dynamic modules on HPUX.

o Fixed some problems with the localinstall target.

o The asynchronous DNS module should now be thread-safe.

o The HTML-parser now parses <!--#foo xxx="yyy"--> correctly.

o Detection of gmp2 added.

o Updated pike/0.6/.how_to_create_modules

o Added detection of broken readdir_r() in Linux (always returns 9).

o Fixed Kinkie's email-address in lots of places.

o conf->sql_connect() now uses a connection-cache.

o Kinkie's Anti-Block System (ABS) hs been added.

o Improved CGI support.

o Added module for FrontPage support.

o Several new formoutput quoting methods have been added.

o The openfiles action now uses <pre> instead of <table>, since
  NS's <table>-handling is so slow.

o Fixed some problems the userfs module had with FTP.

o Some <gtext> updates.

o The pike-script module now has an option to clear password info
  (enabled by default).


Changes since Roxen Challenger 1.2.29 Red
-----------------------------------------------

o SSL3 has been updated to not be vulnerable to the Bleichenbacher
  PKCS#1 attack.

o Applied ftpgateway patch by Wilhelm Koehler <wk@cs.tu-berlin.de>.

o Improved support for ncFTP in ftp2.pike.

o Added check for libm, since Raphsosy doesn't have libm.

o Added kluge to support clients based on SSLeay 0.9.

o Fixed problem sending plain files with SSL3.

o Pike 0.5 SQL API has been updated to Pike 0.6 level.

o Now installs a script to run the Roxen Pike as "$(prefix)/bin/pike-roxen".

o Fixed OLD select() bug in the backend (both Pike 0.5 and 0.6).

o Fixed bug in handling of the default content type.

o Now strips ::$DATA and the like from the filename on NT.

o Added config-interface button to clear the caches associated with
  a virtual server.

o Improved procfs test for Pike 0.5.

o Support for virtual user hosting added to the userfs module.

o Improved error message in case of CGI wrapper execution failure.

o LARGEFILE64 support now compiles on HPUX/gcc.

o Removed some C++-style comments (is there any flag to gcc to
  disable support for C++-style comments?).

o Fixed bug with compiling Pike 0.5 on OS's without support for
  dynamic loading.

o Fixed a few minor 8bit string bugs.

o Fixed bug in file->stat().

o Fixed bugs in the wizard module.

o Added support for <if group=foo>.

o Added support for MODULE_FIRST modules in the gopher protocol (needed on NT).

o Roxen's http protocols module no longer claims to handle protocols other
  than HTTP/0.9, HTTP/1.0 and HTTP/1.1.

o Improved ASN.1 support in Pike 0.6.

o Improved test for threads on FreeBSD.

o A few scope-bugs in Pike 0.6 have been fixed.

o Fixed minor leak in Image.PNG.

o Fixed leak in parse_html_lines().

o Fixed bug in test for existance of passwd.pw_gecos.

o Fixed bug in start-script when run with stupid /bin/sh's (Raphsody).

o Improved statistics output in "Actions"/"Status"/"Access / request status".

o Fixed bug with opening of primary configuration port.

o The CGI variable QUERY_STRING could sometimes be terminated with a \r.

o The "Roxen is alive!" message is now split over serveral lines for
  readability reasons.

o Fixed bug in the profiling information presentation wizard.

o Added a few more MIME types.

o dutch.pike rewritten by Stephen R. van den Berg <srb@cuci.nl>.

o htaccess.pike now knows about the methods used by ftp2.pike.

o Business Graphics updated.

o Fixed filewrapper bug in ftp2.pike.

o Fixed user session counter in ftp2.pike.


Changes since Roxen Challenger 1.2.28 Yellow
-----------------------------------------------

o The HTTP proxy should now work again.
  Thanks to Wilhelm Köhler <wk@cs.tu-berlin.de>.

o pike/0.5/doc/ is now back in the distribution.

o Fixed a few cosmetic bugs.

o pike/0.5/src/modules/files/file.c didn't compile on OS's with broken
  socketpair() (eg SCO).

o Fixed bug in FreeBSD 3.0 detection.

o Applied patch by Andy Church <achurch@dragonfire.net>, which fixes
  the IP address list. Thanks.

o <gtext> now supports PNG on pike's that have Image.PNG.

o The permissions on /tmp/.Roxen_fcgi_pipes/. are now set to 01777.
  Thanks to Kai Garlipp <garlipp@informatik.uni-rostock.de>.


Changes since Roxen Challenger 1.2.27 Yellow
-----------------------------------------------

o Improved debug in the CGI wrapper.

o LARGEFILE_SOURCE support in Pike 0.5.

o Fixes to the Odbc module.

o Improved NT support.

o Pike 0.6 now supports threads on FreeBSD 3.0.

o Improved checks for floatingpoint behaviour in Pike 0.6.

o The start script now supports the option --gdb, which runs Roxen in a gdb.

o Several modules have been updated to Pike 0.6.

o Fixed a few cosmetic bugs.

o ftp2 now supports SITE UMASK.

o Improved HTTP timeout handling.

o Fixed date bug in the ChangeLog creation.

o Fixed several minor bugs.


Changes since Roxen Challenger 1.2.26 Yellow
-----------------------------------------------

o Bug in protocols/http.pike fixed. If a connection was made, but no
  data was sent, the connection wouldn't timeout.

o ntroxenloader.pike now understands -verbose.

o Fixed the testsuite in extern/ so that it is possible to run as root.

o Pike 0.6 now seems to compile on BeOS/x86.

o "Actions"/"Misc" con now be selected properly.

o Fixed problem with erroneous error messages on start on OSs without threads.

o "Actions"/"Maintenance"/"Show all open ports..." now works again.

o Fixed bug in directories.pike.

o userfs.pike now reports banished users only once.

o Fixed stat bug in userfs.pike.

o Fixed "tagname" bug in graphic_text.pike.

o ip-less.pike now checks if the hostname is an IP number.

o cgi.pike now supports "Send stderr to client" in combination with
  "Audit trail".

o #include now works in Pike-scripts again.

o Added the attribute "eval" to the <set> tag.

o Added the new tags <nooutput> and <sort>.

o Improved timeout handling in ftp2.pike.

o Disabled some debug output in the http.pike protocol module.

o The internal server error page now attempts to censor any passwords.


Changes since Roxen Challenger 1.2.25 Yellow
-----------------------------------------------

o Bug in opening of server ports fixed.

o Now only uses smartpipe if THREADS are enabled.

o Added support for the following commands to ftp2.pike:
   CLNT		set CLieNT
   FEAT		list FEATures
   RNFR		ReName FRom
   RNTO		ReName TO
   MLSD		Machine processing LiSt Directory
   MLST		Machine processing LiST
   SITE CHMOD	SITE specific command "CHMOD"

o ftp2.pike has also received some bug-compatibility with Netscape.

o Pike 0.6 has gotten several portability fixes.

o id->handle_request() has been split into two functions id->handle_request(),
  and id->send_result() to make asynchronous I/O easier. Thanks to
  Francesco Chemolli <kinkie@kame.usr.dsi.unimi.it>.

o The testsuite for extern/ now tries to run as nobody if it ran as root.

o The start and install scripts have received some updates needed for the
  latest Pike 0.6.

o The czech language module has been updated and now uses ISO 8859-2.
  Thanks to Jan Petrous <hop@unibase.cz>.

o The filesystem module has been updated to handle MV and CHMOD.
  This was needed for the improved ftp support.

o A new RXML tag: <use>. This tag can be used to define page-local tags
  and containers.

o Improved diagnostic errors in the CGI module and wrapper.

o The gopher protocol module now works again. :-)
  
o Some minor bugs and cosmetic errors have been fixed.


Changes since Roxen Challenger 1.2.24 Yellow
-----------------------------------------------

o Roxen now calls itself 1.3 when run with Pike 0.6.

o The basic filesystem now clears the old entry in the stat-cache for
  files uploaded or deleted.

o Now works with Pike 0.6-NT again.

o Several fixes to the SSL certificate generation code.

o Fixed a couple of more minor leaks in Pike 0.6.

o Improved support for poll(2) in Pike 0.6.

o Improved error messages in Pike 0.6.

o Lots of fixes to Process.create_process() in Pike 0.6.

o Updated a few actions to work with Pike 0.6.

o Fixed some bugs in roxen_master.pike.

o Several fixes to Business Graphics.

o More modules updated to work with Pike 0.6.

o The IP-less module now causes authorization to be against the correct
  auth module, instead of against the master port servers auth module.

o Fixed several bugs in both of the FTP protocol modules.

o Fixed obscure bug in the module loader.

o Fixed several bugs in the CGI-wrapper.

o Added testsuite for the CGI-wrapper.

o Added kluge enabling socketpair() on Linux regardless of wether it
  works or not.

o Protocols.DNS is now more bug-compliant.

o Pike 0.6 now has some poll(2) fallbacks.

o The internal server error page has been improved.


Changes since Roxen Challenger 1.2.21 Yellow
-----------------------------------------------

o LOTS of changes to Pike 0.6.

o Added new module type, MODULE_PROVIDER. This is a module type which
  enables other modules, scripts or protocols to call other modules
  in a standard way. Function needed in the module:

  "string|array|multiset query_provides()" - Return the name of the

  data this module provides. One existing example is "counter"
  (which is the graphical counter module).

  Functions available to other modules:
   object conf->get_provider(string for);
     Get the first (highest priority) provider for "for".
   array (object) conf->get_providers(string for);
     Dito, but return all matching modules.
   void map_providers(string for, string fun, mixed ... args);
     Run the function "fun" in all modules providing "for", with the
     optional arguments "args".
   mixed call_provider(string for, string fun, mixed ... args);
     Run the function "fun" in all modules providing "for", with the
     optional arguments "args" until a positive response
     (!zero). Return the result. This is the main way of calling
     functions in provider modules from other places.
   
o Added new tag - echo. It's usable with one of the following syntaxes:
  <echo var='Remote Host'> <echo remote_host>  <insert remote_host>
  Case doesn't matter and in the first syntax, ' ' and '_' are
  interchangable. The available variables are identical to the SSI
  <!--#echo var="..." -->

o Fix of killframe.

o A new protocol-module - ftp2 has been added, which hopefully will
  work better than the old ftp module.

o htaccess.pike now strips '\r' from the file before parsing.

o Improved handling of opening and closing of configuration ports.

o Various Business Graphics fixes.

o sed module added.

o Several fixes to smartpipe.pike

o Some fixes to graphic_text.pike

o Several fixes to the HTTP protocol module.

o A ChangeLog for the entire Roxen distribution is now automatically
  made from the log entries in out CVS repository.

o Applied patches by Jordi Murgo <jordi@serveis.lleida.net> to
  spanish.pike.

o Applied patches by Wilhelm Köhler <wk@cs.tu-berlin.de> to userfs.pike.

o Added the graphical counter module by Jordi Murgo <jordi@lleida.net>
  to the distribution.  

o All copyright notices should be updated to Idonex, as well as email
  addresses and more.

o Fixed a couple of bugs in the flush cache wizard.

o Several tags have updated documentation (using the "help" option).

o New tag, <list-tags>.

o CGI now works correctly with Pike 0.6. 


Changes since Roxen Challenger 1.2 beta 1
-----------------------------------------------

o New version-numbering scheme. This version of Roxen is called 1.2.21 or
  1.2(21) where 21 is the build-number. Hopefully this is less confusing
  than the old schemes.

o Supports both Pike 0.5 and Pike 0.6.

o Now has support for having several versions of Pike in the distribution.

o Several memory-leaks in Pike have been fixed.

o The CGI-wrapper is now somewhat more paranoid.

o The CGI-wrapper now kills the script and returns an error message if
  it hasn't found the end of the headers (\r\n\r\n) after receiving
  20KB of data. 

o Added the align attribute to the <pr> tag. Same functionality as
  <img align=...>.

o Fixed several obscure bugs that gcc-2.8.0 detected.

o Added version-information to lots of files.

o Experimental keep-alive support added.

o Cleaned up the start-script

o Several performance optimizations.

o Improved thread-handling.

o New file-shuffling code.

o Added support for request-tracing.

o Wizard-generator improved.

o Lots of fixes to Business-Graphics.

o Several minor bugs fixed.


Changes since Roxen Challenger 1.2 alpha 15
-----------------------------------------------

o FTP data connections are now opened on the same IP as the command
  connection is on. This ought to make firewalls happier.

o Fixed an old bug in protocols/ssl3.pike. It should no longer generate
  an internal error when accessing a config-interface with ssl3 using http.

o host lookup now doesn't need any external processes to work. Protocols.DNS
  is used instead.

o The folder list module now works on pages with query variables
  (foo.html?bar=baz&gaz=zonk). The non-fl related variables will be
  kept when unfolding / folding.

o roxen_perror() now reports time synchronously.

o open() of non-existant files speeded up.

o install.pike now checks for existance of protocols/ssl3.pike.

o Fixed obscure bug in roxen_master.pike.

o Applied Henrik P Johnson <hpj@globecom.net>'s fixes to
  modules/filesystems/secure_fs.pike

o Added option to let query to be RXML-parsed in modules/tags/sqltag.pike.

o Parsing of the PEM file-format moved from protocols/ssl3.pike to a new
  Pike-module: SSL.pem.

o Added support for Hungarian. Thanks to Zsolt Varga <redax@agria.hu>.


Changes since Roxen Challenger 1.2 alpha 14
-----------------------------------------------

o Fixed some bugs in the top-level Makefiles.

o Added support for SparcWorks-cc.

o Several fixes of old long-time bugs in Pike:
  o Disappearing call-out bug fixed.
  o Image color-quantifier rewritten.
  o GIF-encoder rewritten.
  o Several threading-bugs fixed.
  o Some fd-leaks fixed.

o Added some sanity-checks to privs.pike

o Some bug-fixes in the wizard-handling.

o Applied some rather large patches to the obox-module by Francesco Chemolli.

o Changed the default mode of the ftp-protocol module to ASCII.


Changes since Roxen Challenger 1.2 alpha 13
-----------------------------------------------

o Problems distributing crypto-code outside Sweden.

o New status action: Extended process status for Linux. It uses pstree
  and the /proc/ file system. A bonus is that it can be used as a
  general process tree browser!

o Added a configurable "default content type" to the Content type
  module. Now it's easy to use text/plain instead of the default
  application/octet-stream for all unknown files.

o Location-modules now have a secondary sorting-order (longest path first),
  which removes some cases where priorities were needed before.

o SSL3 now reads data to be sent nonblocking, so cgi-scripts should work again
  on https ports.

o Business Graphics module added.

o Cleaned up the output from some of the Makefiles.

o Disabled the non-working SGI sproc()-support fully.

o Workaround for PANIC-causing bug in AIX.

o Improved support for cyclic structures in Pike.

o Kluge added to support the libz distributed with IRIX 6.3.

o Improved colortable support in the Image module.

o The Msql and Postgres modules by Francesco Chemolli added to the
  distribution.

o The <sqltable> tag now takes an optional attribute "ascii" to generate
  a tab-separated output suitable for eg the <diagram> tag.

o The Makefiles now pass along more arguments to the sub-makes.

o -pipe option to gcc disabled since it caused configure to hang when
  configuring gmp.

o Several warnings when compiling fcgi fixed.

o THREADS disabled on all OS's except Solaris.

o Neighbourhood disabled by default. Define ENABLE_NEIGHBOURHOOD to enable it
  again.

o pike/src/modules/Pipe/pipe.c reverted to version 1.11 due to problems
  with 1.12 and later.

o Fixed several bugs in the CVS filesystem.

o Fixed some not-binary-clean bugs in the proxy.

o The sqltag-module now only has one config-variable (unless SQL_TAG_COMPAT
  is defined).

o Some bugs in the ftp protocol-module fixed.

o pikescript removed from the generic-server template.


Changes since Roxen Challenger 1.2 alpha 12
-----------------------------------------------

o Added a new module. <pimage></pimage>. This tag has the same security 
  impact that the <pike></pike> tag has, and should not be enabled for 
  untrusted filesystems.

  Examples of usage are in the (new) examples directory.

o Added threading to the ftp protocol-module at last.

o The ftp protocol-modules built-in ls now has support for several more flags.

o Several configure-script fixes.

o The <if> tag in combination with the <else> tag now work as people have
  assumed them to.

o The sql-tags can now be used together with the <else> tag.

o Applied CGI fix by Eric Lammerts <eric@scintilla.utwente.nl>.

o CGI's are now forked from the backend thread to avoid confusing some OS's.

o Fixed several race-conditions when running with THREADS enabled.

o Updated supplied gmp to gmp-2.0.2-ssh-2.

o Removed several arbitrary limits.

o Some neighbourhood fixes.

o Some internal security fixes.

o Applied hostredirect fix by Martin Baehr <mbaehr@email.archlab.tuwien.ac.at>.


Changes since Roxen Challenger 1.2 alpha 11
-----------------------------------------------

o Threads now work better.

o The start-script now sets the umask to 022, to be certain it can read
  the files Roxen creates.

o Some fixes to the neigbourhood system.

o The mutex-code in pike/src/treads.c rewritten, optimized and bugfixed.
  The need for mutex_kluge has been removed.
  Locking an unlocked mutex now doesn't involve any thread-operations at all.
  Several race-conditions removed.

o The compiler-option -sopt for IRIX-cc has been disabled since it caused the
  compiler to hang on interpret.c

o Improved tests for the Gz-module.

o Several fixes to support stupid C preprocessors.

o Fixes to the UDP code.

o The supplied version of gmp now compiles on Solaris 2.6 x86.

o ((program)"privs") assigned to a constant (Privs) to improve efficiency.

o Now opens all ports at the beginning of the boot-sequence to keep
  "Connection refused" time to a minimum.

o The log-file filename can now contain the current date and time.

o Removed some race-conditions.

o Now possible to select server to upgrade from.


Changes since Roxen Challenger 1.2 alpha 10
-----------------------------------------------

o Threads are enabled by default, and actually work.

o The HTTP protocol now does it's very best to log the ACTUAL number
  of sent bytes, even for CGI scripts. It will not work for
  modules (or pike-scripts) that use the http_pipe_in_progress()
  function, though, but to my knowledge there are no such modules in
  the Roxen distribution, with the exception of the Proxy module,
  which will not be logged in the normal log anyway.

  I had to remove support for the external shuffle program for this to
  work. This program was not very helpful anyway, unless you run
  Solaris 2.4 it only slows things down, if you do not have a multi
  CPU machine, in which case the internal thread support in Roxen is
  better anyway.

o Added some more directories to search by default for nfonts and modules.
  "../local/modules" and "../local/nfonts". Roxen will by default not install
  anything in these directories.

o The configure-scripts are now better att choosing optimizer options.

o The neighbourhood function can now also use TCP.

o Several config_actions updated.

o Directory-module cache-problem fixed.

o Many modules now marked as thread-safe.

o The gtext-module now uses typographically correct spacing.

o The sqltag-module now has improved documentation.

o Pike version bumped to 0.5b10.

o The number of FTP users can now be viewed under "Status and debug info".

o The FTP built-in ls now uses the Getopt-module to parse its arguments.
  It also sends the data asynchronously for improved response-times. Not
  threaded (yet).

o The FTP built-in ls now supports -R.

o Fixed double \r-bug in the simulated "ls -l" in the ftp-protocol module.

o The ftp-protocol module now supports the MDTM (modification time) command.

o Fixed bug in the setting of the default domain.


Changes since Roxen Challenger 1.2 alpha 9
-----------------------------------------------

o The Languagemodule now supports Accept-Language headers and is
  capable of presenting directory listings.

o Minor redesign of the buttons in the config-interface.

o Copying of configurations now works again.

o The htaccess module is now a MODULE_URL module, which improves the internal
  security in Roxen.

o Improved fallbacks in the htaccess-module.

o The start-script now uses the pike named "roxen" if it exists, so that
  Roxen shows up as "roxen" instead of as "pike" in process-listings.

o The LIST and NLST commands in the ftp-module now support glob-patterns.

o Libraries needed for the Gdbm, Gmp and Gz modules added to the distribution.

o WideValues and CommonLog Pike-modules added.

o Added "Easy Build" Makefile to top directory. It should now be possible to
  just type "make; make install" to get a Roxen buildt and installed on most
  Operating Systems. The default prefix (/usr/local) will be used for the
  installation.

o Configurationfiles older than Spinnerb11p11 no longer supported.

o Roxen can now register itself with other Roxen servers on the same local
  network. See "Actions:Neighborhood:Roxen Neighbourhood...". This is very
  useful if you have several Roxen servers.

o The actions are now grouped.

o Added wizard-interface for easy construction of wizards.

o Added some more actions.

o Documentation-strings added to many modules for use by the upgrade action.

o Bugfixes to the host-redirect module.

o Added module for easy IP-less virtual host configuration.

o Language-module updated.

o The flik-module now has support for being in frames uses <a name> to
  automaticly center on the right place.

o The http-protocol module now handles multipart/form-data correctly.
  This might affect some old form-handling code.

o tools/init.d_roxen now supports HP-UX's init.d-system.

o Added option to disable anonymous ftp.

o Bug with never dieing cgi-scripts fixed.

o The start-script now waits 5 seconds before restarting Roxen. This
  is to keep it from taking 100% CPU if Roxen fails to load.

o Updated README.ssl3 file.

o Shuffle disabled for everything except Solaris 2.4, 2.5 and 2.5.1.

o feature_list now checks for some more modules.

o CommonLog and WideValues modules added to the standard distribution.

o Missing Sql.pmod glue added.

o Sql conventions changed somewhat. Data-values returned from queries are
  now either a string with the value, or zero (0) for NULL.

o Added config-check for broken installbsd on AIX.

o /roxen-internal-* images may now be jpegs.

o Contents under the "Status"-tab moved to actions.

o New demo-certificate for ssl.

o Module for IP-less hosting added. Simply add this module to the virtual-
  servers having real ports, and it will redirect requests to the virtual-
  server whose server-URL matches the host-header best.

o Added the sqltag-module to the default distribution.


Changes since Roxen Challenger 1.2 alpha 8
-----------------------------------------------

o When you save port changes in virtual servers (and also the
  configuration ports), you now get a page where you are prompted to
  change the virtual server URL (or configuration URL). You can choose
  between the different ports and the current one, which you can also
  modify to something else. This should decrease the number of
  misconfigured server URLs drastically.

o Shutdown and restart have moved to the Actions tab.

o Several other actions added.

o Now opens the configuration port(s) first instead of last.

o Colors in the configuration interface changed to the official
  Infovav User Interface Colors. Some other changes to the layout as well.

o Changed the name of the 'Error Log' to 'Event Log', since that is a
  more apropriate name. Also fixed it's layout.

o Added a new tag: <pr>. Use <pr help> to get some help.
  Basicaly it just adds an 'Powered By Roxen' logo.

o The FTP-protocol module now sends a nice message when it shuts down a
  connection due to timeout.

o The SSL3-module is now used in favour of the old SSL-protocol modules,
  which in turn have at last been removed.

o Module-level security improved again.

o Two new functions in roxenlib.pike:
  - html_encode_string -> replaces <>& with &lt;
  - html_encode_tag_value -> encodes a string for use as a value in an
    html tag (ie 'bar " & " ' -> '"bar &quot; &amp; &quot; "').

o & was displayed as ä in some fields in configuration interface due
  to the use of a buggy html_encode_string. 

o internal-roxen-* and internal-gopher-* are not parsed if
  id->not_query doesn't start with '/'. Before the Roxen proxy
  "nicely" took care of them.

o Added support for subnet-based IP security.

o Module-variables can now be tagged as less interresting, and are then
  shown only in more-mode.

o Added possibility to disable directory-listing overrides to the
  fastdirectory-module.

o The mirror server and client now have some documentation.

o The restricted-filesystem now supports hiding the path to the
  home-directory.

o Fixed some CGI environment-variable bugs.


Changes since Roxen Challenger 1.2 alpha 7
-----------------------------------------------

o The SSL3 module now returns a redirect if it is accessed with HTTP.

o CGI security fix.

o Tetris-protocol added.

o Got rid of "Calling function in a destructed object" when SSL3 connections
  are broken.

o Restricted filesystem added. This filesystem restrictes access to
  directories prefixed by the users home-directory. This is useful for eg
  an FTP-server. Thanks to Zsolt Varga <redax@agria.hu> for the idea.

o SSL3 ports now work without restarting the server.

o Copying configurations now works again.

o privs.pike now clears supplementary group list in case initgroups fails.

o Added kludge for HPUX's broken grouphandling.

o Bugfix for the ftp-module if there aren't any MODULE_FIRST modules.

o configvar can now be started again.

o Single-letter options can now be passed to the start-script.

o Backward-compatibility patch to color.pike.

o Security-levels made a bit less paranoid.

o Logformat fix.

o "New module" button renamed to "Add module".

o Protocol-modules now get the configuration-object as the second argument
  to create().

o Now works again with a threaded pike on Linux.

o CGI problems with SCRIPT_NAME/PATH_INFO hopefully fixed.

o stdin, stdout and stderr can now be specified to spawn_pike().

o activex added to supports-file.

o Added missing parts needed for the mirror-filesystem client/server.
  NOTE: Do NOT generate circular dependencies with mirror-filesystems, or
  there is risk of deadlock.

o The hostredirect-module now handles the case that the host-header isn't
  specified correctly.

o The flik-module now has alt-texts.

o Added support for some more HTTP-proxy-headers.


Changes since Roxen Challenger 1.2 alpha 6
-----------------------------------------------

o New modules: Mirror Filesystem and Mirror Server.  Add a mirror
  server to the server you want to mirror, and a Mirror Filesystem in
  all mirrors. The searchpath of the Mirror Filesystem is used as a
  cache.  It is not a good idea to use the same cache-directory with
  multiple mirror filesystems. There is a mirror for www.roxen.com at
  skuld:2000. The mirror filesystem does not mirror the needed
  modules, though.

o Added option to create FTP servers.

o SSL3 speeded up.

o Reenabled the "Roxen is alive!" output even if DEBUG isn't defined.

o Added option to attempt setting of the RoxenUserID cookie only once.
  Thanks to Francesco 'Kinkie' Chemolli <kinkie@kame.usr.dsi.unimi.it>.

o Added option to disable sym-link following to the normal filesystem.

o Added language modules for Croatian and Slovenian.

o cgi.c now compiles on HPUX again.

o Pike updated to 0.5b9.

o color.pike rgb_to_hsv() fixed for grayscales.

o Module-level security now supports combinations of allow ip and allow user.

o Some patches to the disk-cache.

o Support for several font directories added.

o roxen_hostname now started as root.

o language-modules are now initialized in a safer way.

o privs.pike now contains a default-entry for the root user.

o MIME.decode_base64() now used to decode HTTP-passwords.

o Now gets updates from www.roxen.com instead of from roxen.com.

o Reloading of the "New module" page now only recompiles the modified modules.

o Some fixes to parse_rxml().

o Some fixes to the relay-module.

o Gtext-module now supports scroll.

o Fixed CGI-bug.

o Fixed FTP security bug.

o Added profiling-info to debug-info for developers (requires patch to Pike).

o htaccess now defaults the limit for HEAD to the same as that for GET.


Changes since Roxen Challenger 1.2 alpha 5
-----------------------------------------------

o Fixed the 'default' type in etc/extensions. It should be checked
  now..

o The images in the configuration interface is now cached on
  disk. This seems to speed things up on slow machines, and the images
  will work on HP's where gcc is used...

o Fixed a bug in the .htaccess related to the removal of previously
  loaded .htaccess files.

o Fixed some documentation in the graphics text module

o The hsv colorspace in color.pike has been fixed somewhat, 
  to specify a color in the HSV colorspace, use @H,S,V.
  H is a number between 0 and 360, S anv V are numbers between 0 and
  100 (percent).

o It is now possible to specify colors like 'light neon dark light green'.
  The spaces are quite optional. Possible colormodifiers include
  light, dark and neon.
  
o Added better checks during module-initialization.

o Fixed permission bug in the ftp-module.

o Ftp-module now supports DELE.

o Fixed file_stat() in roxen_master.pike.

o Several MIME-types added.

o Userdatabase module using YP (NIS) added.

o POSIX_SOURCE is now defined during the configure tests.

o The quite meaningless error message
  "This is (probably) the reason: 0" is hopefully gone now.

o Now uses correct permissions when updating the etc/supports file.

o #!NO in modules now seems to work.

o Garbage-collector updated (thanks to Wilhelm Köhler).

o THREADS-mode can now use multiple shuffle-threads (thanks to Wilhelm Köhler).
  To try THREADS (very alpha..) edit etc/include/config.h
  
o Some bugs in the proxies fixed.


Changes since Roxen Challenger 1.2 alpha 4
-----------------------------------------------

o Reenabled the config-interface error-log.

o You can now use path's like /cvs:/roxen_src/server/modules as a module
  directory. Not really all that useful (the modules will be read from 
  CVS automatically, thus ensuring that the latest version is used), but 
  it might be useful for groups of people running concurrent development 
  of roxen modules (like we at infovav..), there is no need to check out 
  the latest version of a module before it can be reloaded in the server.

  the CVSROOT environment variable will be used as the CVS root.

  This was added as an extension to get_dir, stat_file and 
  (program)"string"; (see the etc/roxen_master.pike file)

  So normal pike-scripts can also take advantage of this.

  This is only enabled if CVS_FILESYSTEM is defined.

o The somewhat annoying 'Roxen is alive!' message will no longer be 
  written to the log once per minute unless something else is written
  to the log. It will only be output once if DEBUG isn't defined.

o Root execution of CGI scripts disabled.

o Shuffle disabled for all OS's except Solaris 2.x on sparc.

o Logfiles now opened as root.

o Ftp-module now gives error message instead of sending an error-file.

o .htaccess-module now filters files starting with ".ht".

o Added height specification to module-list images. The module-list should
  now display *much* faster.

o Some patches to disk_cache.pike. It no longer uses FILE objects per 
  default (they cannot be used in non-blocking mode), instead File() 
  objects are used (raw files). Also, the ROXEN_HEAD_SIZE define is not 
  added to headers->headers_size multiple times. Also, the use of 
  file->tell() has been removed, since that function seems to be somewhat 
  broken in FILE (stdio like) objects.

o Some patches for those who are brave enough to run with THREADS enabled.
  Most debug output removed.

o Some new extensions to MIME content-types mappings in the etc/extensions 
  file.

o Applied some patches by Wilhelm Köhler.

o Some patches to language.pike. It no longer uses the value of the LANG 
  environment variable to select the default language. ROXEN_LANG is used 
  instead.

o Replaced all remaining instances of roxen->query with id->conf->query.

o proxy.pike now uses the global shuffle function.

o Cleaned up some of the prestate handling code.


Changes since Roxen Challenger 1.2 alpha 3
-----------------------------------------------

o Now uses Pike 0.5b7.

o make install now saves the last 2 versions of the server.

o color.pike now has support for the HSV color-space.

o Some patches to disk_cache.pike.

o Applied some patches by Wilhelm Köhler.

o Roxen now returns time in GMT

o http module fd-leak work-around.

o Extensions .{c,cc,h} now are subtypes of text instead of application.

o Intraseek added to set of robots.

o italian.pike updated by Francesco Chemolli.

o The user filesystem nolonger hangs if the public directory is a file.

o Some patches to ismap.pike.

o Fixes to language.pike.

o Patched ftpgateway.pike.

o Patched proxy.pike.

o Pikescripts can now use #include.

o Added handling of exec bit on HTML-files.

o Some nicer error-messages from the SSL3-module.


Changes since Roxen Challenger 1.2 alpha 2
-----------------------------------------------

o Fixes to module-level security.

o Enabled some debug output from the host-name lookup module.

o Added some support for OS's lacking effective user/group.

o New functions program_filename and program_directory in roxenlib.pike.

o New global function spawn_pike in roxenloader.pike.

o Patches to hostredirect.pike, ismap.pike, proxy.pike.

o Applied patches by Wilhelm Köhler.

o Security patch to cgi.pike.


Changes since Roxen Challenger 1.2 alpha 1
-----------------------------------------------

o Patch for cgi.c to enable compilation on FreeBSD.

o Removed several C++ //-style comments.

o roxen->shuffle now works on OS's without send_fd.

o Install script now queries if you want SSL3 or not.

o Install script now doesn't install SSL3 if you don't have GMP.

o Minor fix to graphic_text.pike.


Changes since Roxen Challenger 1.1.1 alpha 6
-----------------------------------------------

o etc/master.pike has been renamed to etc/roxen_master to avoid
  name conflicts/confusion.

o Support for SSLv3 added.
  NOTE: This module uses strong encryption, which may violate local law.
	In the US this module violates patents held by RSA Inc.
  A version of Roxen without the crypto-module will be made available
  on demand.

o The install-script now uses ssl3 for the configuration port.

o Added support for setting the cpu-limit and nice-level for CGI-scripts.

o Some patches to shuffle.

o Some patches to ssl.

o Some patches to fcgi.

o Several functions have moved from roxen->X to id->conf->X to allow for
  threads.

o Fixed the install-script.

o Should now start the garbage-collector correctly when started from a
  standard installation.

o Applied a LARGE patch for the disk cache by Wilhelm Köhler (Thanks!)

o Applied another patch by Wilhelm Köhler (Thanks again!)

o Fixed most of the bugs in the ticket-database.

o Fixed several small bugs here and there.

o Ftp-module now supports STOR.

o Ftp-module now restores auth-information for every transaction. This is
  necessary since eg the htaccess-module modifies the auth-field, which is
  fine for single-transaction protocols like HTTP, but won't do for
  multiple-transaction protocols like FTP.

o Ftp-module now supports setting prestates via SITE PRESTATE.

o Added some new top-level Makefile targets:
  install_all		Install both Roxen and Pike.
  install_pike		Install only Pike.
  verify		Run Pikes testsuite.
  verbose_verify	Run Pikes testsuite in verbose mode.


Changes since Roxen Challenger 1.1.1 alpha 5
-----------------------------------------------

o Now uses Pike 0.5b4

o Shrunk the roxen-master.

o The FTP-protocol module now supports named FTP. This is implemented by
  mounting / on / and having "allow user=any" in "Security: Patterns".
  One interesting feature is that users using named FTP can still see
  the anonymous tree.

o Added support for MODULE_FIRST modules to the FTP-protocol module. This
  allows for using .htaccess-files to restrict access to certain directories.

o Install-script updated.

o Now sets --prefix to . for the Pike-tree.

Changes since Roxen Challenger 1.1.1 alpha 2
-----------------------------------------------

o Now uses replace_master().

o proxy_auth_needed() has moved to roxenlib.

o Many files updated to Pike 0.5b2.

o Startscript now inserts the value of the environment variable DEFINES
  into commandline.

o /precompiled/* no longer supported; use the new module-system instead.


Changes since Roxen Challenger 1.1 
-----------------------------------------------

o The host redirect module has been improved by Martin Baehr.

o Support for shadow passwords added to userdb (method shadow). The
  default method is always set to file. If getpwent is used on a system
  with thousands of users, it takes a VERY long time to read all the
  users. 

o allow/deny user using 'any' was broken in the last fix. This is, of
  course, fixed now.

o <apre href=#foo> and others now works as expected.

o Install script now doesn't append the domain name if it's already in
  the hostname (which is the case in BSD UNIXes).

o etc/extensions is now more complete.

o The convert_accessed.pike script fixed. Someone forgot committing
  the bugfixed version before the release.

o Fix in the host->ip functions. Before Roxen assumed that there were
  no hostnames that started with en in (for example
  50foo.bar.com). This little misfeature is fixed now. Before the
  proxy never worked with one of these hosts. The bug was found by
  Iztok Umek <Iztok.Umek@snet.fri.uni-lj.si>. Thanks!
  
o Bugfix in module security. You now get the "403 Forbidden" return
  code if your IP isn't allowed to view a page, instead of "404 Not
  Found". Thanks to Kai Garlipp <garlipp@informatik.uni-rostock.de>
  for the patch.

o Added container <formoutput> to simplify using forms.
	
